Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterMutationCombinedOperator.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterMutationCombinedOperator.cs	(revision 10101)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterMutationCombinedOperator.cs	(revision 10102)
@@ -20,4 +20,5 @@
 #endregion
 
+using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("QAPAfterMutationCombinedOperator", "An operator that contains all operators that need to be executed after mutation for the QAP.")]
   [StorableClass]
-  public class QAPAfterMutationCombinedOperator : AfterMutationCombinedOperator {
+  public class QAPAfterMutationCombinedOperator : AfterMutationCombinedOperator, IPermutationAdvice {
     [StorableConstructor]
     protected QAPAfterMutationCombinedOperator(bool deserializing) : base(deserializing) { }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TFAfterMutationCombinedOperator.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TFAfterMutationCombinedOperator.cs	(revision 10101)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TFAfterMutationCombinedOperator.cs	(revision 10102)
@@ -20,4 +20,5 @@
 #endregion
 
+using HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("TFAfterMutationCombinedOperator", "An operator that contains all operators that need to be executed after mutation for test functions.")]
   [StorableClass]
-  public class TFAfterMutationCombinedOperator : AfterMutationCombinedOperator {
+  public class TFAfterMutationCombinedOperator : AfterMutationCombinedOperator, IRealVectorAdvice {
 
     [StorableConstructor]
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TSPAfterMutationCombinedOperator.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TSPAfterMutationCombinedOperator.cs	(revision 10101)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TSPAfterMutationCombinedOperator.cs	(revision 10102)
@@ -20,4 +20,5 @@
 #endregion
 
+using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("TSPAfterMutationCombinedOperator", "An operator that contains all operators that need to be executed after mutation for the TSP.")]
   [StorableClass]
-  public class TSPAfterMutationCombinedOperator : AfterMutationCombinedOperator {
+  public class TSPAfterMutationCombinedOperator : AfterMutationCombinedOperator, IPermutationAdvice {
     [StorableConstructor]
     protected TSPAfterMutationCombinedOperator(bool deserializing) : base(deserializing) { }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10101)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10102)
@@ -127,8 +127,10 @@
     <Compile Include="Algorithm\SolutionCacheAnalyzerAlgorithm.cs" />
     <Compile Include="Algorithm\ParallelOperatorProcessor.cs" />
+    <Compile Include="MutationPointcut.cs" />
     <Compile Include="CrossoverPointcut.cs" />
     <Compile Include="IAdvice.cs" />
     <Compile Include="IPointcut.cs" />
     <Compile Include="ISolutionCache.cs" />
+    <Compile Include="PermutationEncoding\PermutationMutationPointcut.cs" />
     <Compile Include="PermutationEncoding\IPermutationAdvice.cs" />
     <Compile Include="PermutationEncoding\IPermutationPointcut.cs" />
@@ -139,4 +141,5 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="RealVectorEncoding\RealVectorMutationPointcut.cs" />
     <Compile Include="RealVectorEncoding\IRealVectorAdvice.cs" />
     <Compile Include="RealVectorEncoding\IRealVectorPointcut.cs" />
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/MutationPointcut.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/MutationPointcut.cs	(revision 10102)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/MutationPointcut.cs	(revision 10102)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Analysis.SolutionCaching {
+  [StorableClass]
+  public abstract class MutationPointcut<TA, TM> : SingleSuccessorOperator, IManipulator, IStochasticOperator, IPointcut
+    where TA : class, IAdvice
+    where TM : class, IManipulator {
+    protected const string AdviceParameterName = "Advice";
+    protected const string MutatorsParameterName = "Mutators";
+
+    public ConstrainedValueParameter<TM> MutatorsParameter {
+      get { return (ConstrainedValueParameter<TM>)Parameters[MutatorsParameterName]; }
+    }
+    public ConstrainedValueParameter<TA> AdviceParameter {
+      get { return (ConstrainedValueParameter<TA>)Parameters[AdviceParameterName]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    [StorableConstructor]
+    protected MutationPointcut(bool deserializing) : base(deserializing) { }
+    protected MutationPointcut(MutationPointcut<TA, TM> original, Cloner cloner) : base(original, cloner) { }
+
+    public MutationPointcut()
+      : base() {
+      var advices = new ConstrainedValueParameter<TA>(AdviceParameterName,
+        "Advice to introduce after crossover");
+      foreach (var a in ApplicationManager.Manager.GetInstances<TA>()) {
+        advices.ValidValues.Add(a);
+      }
+      Parameters.Add(advices);
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new ConstrainedValueParameter<TM>(MutatorsParameterName, "The mutators."));
+    }
+
+    public override IOperation Apply() {
+      IOperation successor = base.Apply();
+      IOperation mutationOperation = ExecutionContext.CreateChildOperation(MutatorsParameter.Value);
+      IOperation adviceOperation = ExecutionContext.CreateChildOperation(AdviceParameter.Value);
+
+      var opCol = new OperationCollection();
+      opCol.Add(mutationOperation);
+      opCol.Add(adviceOperation);
+      if (successor != null)
+        opCol.Add(successor);
+
+      return opCol;
+    }
+  }
+}
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationMutationPointcut.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationMutationPointcut.cs	(revision 10102)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationMutationPointcut.cs	(revision 10102)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Analysis.SolutionCaching.PermutationEncoding {
+  [Item("PermutationMutationPointcut", "Wraps a mutator and applies after-mutation actions.")]
+  [StorableClass]
+  public class PermutationMutationPointcut : MutationPointcut<IPermutationAdvice, IPermutationManipulator>, IPermutationManipulator, IPermutationPointcut {
+    public ILookupParameter<Permutation> PermutationParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["Permutation"]; }
+    }
+
+    [StorableConstructor]
+    protected PermutationMutationPointcut(bool deserializing) : base(deserializing) { }
+    protected PermutationMutationPointcut(PermutationMutationPointcut original, Cloner cloner) : base(original, cloner) { }
+
+    public PermutationMutationPointcut()
+      : base() {
+      Parameters.Add(new LookupParameter<Permutation>("Permutation", "The permutation that is being manipulated."));
+
+      foreach (Type t in ApplicationManager.Manager.GetTypes(typeof(IPermutationManipulator))) {
+        if ((!typeof(PermutationMutationPointcut).IsAssignableFrom(t)) &&
+          (!typeof(MultiOperator<IPermutationManipulator>).IsAssignableFrom(t))) {
+          MutatorsParameter.ValidValues.Add((IPermutationManipulator)Activator.CreateInstance(t));
+        }
+      }
+
+      ParameterizeManipulators();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationMutationPointcut(this, cloner);
+    }
+
+    private void ParameterizeManipulators() {
+      foreach (IPermutationManipulator manipulator in MutatorsParameter.ValidValues.OfType<IPermutationManipulator>()) {
+        manipulator.PermutationParameter.ActualName = PermutationParameter.Name;
+      }
+      foreach (IStochasticOperator op in MutatorsParameter.ValidValues.OfType<IStochasticOperator>()) {
+        op.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorMutationPointcut.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorMutationPointcut.cs	(revision 10102)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorMutationPointcut.cs	(revision 10102)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding {
+  [Item("RealVectorMutationPointcut", "Wraps a mutation and applies after-mutation actions.")]
+  [StorableClass]
+  public class RealVectorMutationPointcut : MutationPointcut<IRealVectorAdvice, IRealVectorManipulator>, IRealVectorManipulator, IRealVectorPointcut {
+    public ILookupParameter<RealVector> RealVectorParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["RealVector"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+
+    [StorableConstructor]
+    protected RealVectorMutationPointcut(bool deserializing) : base(deserializing) { }
+    protected RealVectorMutationPointcut(RealVectorMutationPointcut original, Cloner cloner) : base(original, cloner) { }
+
+    public RealVectorMutationPointcut()
+      : base() {
+      Parameters.Add(new LookupParameter<RealVector>("RealVector", "The real vector that is being manipulating."));
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds of the real vector."));
+
+      //Would be nicer if it comes from operator collection, but MultiRealVector Crossover does the same thing.
+      //Also: MultiRealVectorCrossover cannot be used here as it would generate a cyclic recursion 
+      //MultiRealVectorCrossover discovers RealVectorCrossoverPointcut which discovers Multi....
+      foreach (Type t in ApplicationManager.Manager.GetTypes(typeof(IRealVectorManipulator))) {
+        if ((!typeof(RealVectorMutationPointcut).IsAssignableFrom(t)) &&
+          (!typeof(MultiOperator<IRealVectorManipulator>).IsAssignableFrom(t))) {
+          MutatorsParameter.ValidValues.Add((IRealVectorManipulator)Activator.CreateInstance(t));
+        }
+      }
+
+      ParameterizeManipulators();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorMutationPointcut(this, cloner);
+    }
+
+    private void ParameterizeManipulators() {
+      foreach (IRealVectorManipulator manipulator in MutatorsParameter.ValidValues.OfType<IRealVectorManipulator>()) {
+        manipulator.RealVectorParameter.ActualName = RealVectorParameter.Name;
+        manipulator.BoundsParameter.ActualName = BoundsParameter.Name;
+      }
+      foreach (IStochasticOperator manipulator in MutatorsParameter.ValidValues.OfType<IStochasticOperator>()) {
+        manipulator.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}