Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 10114)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 10116)
@@ -91,4 +91,9 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.TravelingSalesman-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.TravelingSalesman-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
@@ -104,4 +109,6 @@
     <Compile Include="RealVectorConvexHullSolutionCacheAnalyzer.cs" />
     <Compile Include="DistanceMatrixToPoints.cs" />
+    <Compile Include="RunCollectionModifiers\PermutationConvexHullModifier.cs" />
+    <Compile Include="RunCollectionModifiers\RealVectorConvexHullModifier.cs" />
     <Compile Include="VertexComparer.cs" />
     <Compile Include="CombinedOperator.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/Plugin.cs.frame
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/Plugin.cs.frame	(revision 10114)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/Plugin.cs.frame	(revision 10116)
@@ -31,4 +31,6 @@
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.RealVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.TravelingSalesman", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RealVectorConvexHullSolutionCacheAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RealVectorConvexHullSolutionCacheAnalyzer.cs	(revision 10114)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RealVectorConvexHullSolutionCacheAnalyzer.cs	(revision 10116)
@@ -54,5 +54,5 @@
 
       while (sols.Count != 0) {
-        var input = sols.Select(x => ConvertPermutationToVertex(x)).ToArray();
+        var input = sols.Select(x => ConvertRealVectorToArray(x)).ToArray();
         var convexHull = LPHull.Calculate(input);
         var volume = ConvexHullMeasures.CalculateVolume(convexHull);
@@ -66,5 +66,5 @@
     }
 
-    private double[] ConvertPermutationToVertex(RealVector p) {
+    private double[] ConvertRealVectorToArray(RealVector p) {
       double[] vertex = p.Select(x => (double)x).ToArray();
       return vertex;
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionModifiers/PermutationConvexHullModifier.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionModifiers/PermutationConvexHullModifier.cs	(revision 10116)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionModifiers/PermutationConvexHullModifier.cs	(revision 10116)
@@ -0,0 +1,89 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
+using HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.TravelingSalesman;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("PermutationConvexHullModifier", "Calculates the convex hull from a solution cache. ")]
+  [StorableClass]
+  public class PermutationConvexHullModifier : ParameterizedNamedItem, IRunCollectionModifier {
+    private const string SolutionCacheResultName = "SolutionCache";
+
+    [StorableConstructor]
+    protected PermutationConvexHullModifier(bool deserializing) : base(deserializing) { }
+    protected PermutationConvexHullModifier(PermutationConvexHullModifier original, Cloner cloner) : base(original, cloner) { }
+    public PermutationConvexHullModifier() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationConvexHullModifier(this, cloner);
+    }
+
+    public void Modify(List<IRun> runs) {
+      foreach (var run in runs) {
+        int i = 0;
+        if (!run.Results.ContainsKey(SolutionCacheResultName)) continue;
+        var solutionCache = run.Results.Single(x => x.Key == "SolutionCache").Value as PermutationSolutionCache;
+        if (solutionCache == null) continue;
+
+        DataTable dt = new DataTable("Convex Hull Volume over Generations");
+        DataRow dtVolumeRow = new DataRow("Volume");
+        DataRow dtNrPointsRow = new DataRow("Nr. of Points");
+        dt.Rows.Add(dtVolumeRow);
+        dt.Rows.Add(dtNrPointsRow);
+
+        var sols = solutionCache.GetSolutionsFromGeneration(i);
+        int dim = sols.First().Length;
+        while (sols.Count != 0) {
+          double[][] dm = new double[sols.Count][];
+          for (int j = 0; j < sols.Count; j++) {
+            dm[j] = new double[sols.Count];
+          }
+
+          for (int j = 0; j < sols.Count; j++) {
+            for (int k = 0; k < sols.Count; k++) {
+              dm[j][k] = TSPSimilarityCalculator.CalculateSimilarity(sols[j], sols[k]);
+            }
+          }
+          double[][] popPoints = DistanceMatrixToPoints.ConvertDistanceMatrixToPoints(DistanceMatrixToPoints.MetricMDS(dm, dim, true));
+
+          var convexHull = LPHull.Calculate(popPoints);
+          var volume = ConvexHullMeasures.CalculateVolume(convexHull);
+          dtVolumeRow.Values.Add(volume);
+          dtNrPointsRow.Values.Add(convexHull.Count);
+
+          sols = solutionCache.GetSolutionsFromGeneration(++i);
+        }
+
+        run.Results.Add("Convex Hull Measures", dt);
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionModifiers/RealVectorConvexHullModifier.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionModifiers/RealVectorConvexHullModifier.cs	(revision 10116)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionModifiers/RealVectorConvexHullModifier.cs	(revision 10116)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("RealVectorConvexHullModifier", "Calculates the convex hull from a solution cache. ")]
+  [StorableClass]
+  public class RealVectorConvexHullModifier : ParameterizedNamedItem, IRunCollectionModifier {
+    private const string SolutionCacheResultName = "SolutionCache";
+
+    [StorableConstructor]
+    protected RealVectorConvexHullModifier(bool deserializing) : base(deserializing) { }
+    protected RealVectorConvexHullModifier(RealVectorConvexHullModifier original, Cloner cloner) : base(original, cloner) { }
+    public RealVectorConvexHullModifier() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorConvexHullModifier(this, cloner);
+    }
+
+    public void Modify(List<IRun> runs) {
+      foreach (var run in runs) {
+        int i = 0;
+        if (!run.Results.ContainsKey(SolutionCacheResultName)) continue;
+        var solutionCache = run.Results.Single(x => x.Key == "SolutionCache").Value as RealVectorSolutionCache;
+        if (solutionCache == null) continue;
+
+        var sols = solutionCache.GetSolutionsFromGeneration(i);
+        DataTable dt = new DataTable("Convex Hull Volume over Generations");
+        DataRow dtVolumeRow = new DataRow("Volume");
+        DataRow dtNrPointsRow = new DataRow("Nr. of Points");
+        dt.Rows.Add(dtVolumeRow);
+        dt.Rows.Add(dtNrPointsRow);
+
+        while (sols.Count != 0) {
+          var input = sols.Select(x => ConvertRealVectorToVertexArray(x)).ToArray();
+          var convexHull = LPHull.Calculate(input);
+          var volume = ConvexHullMeasures.CalculateVolume(convexHull);
+          dtVolumeRow.Values.Add(volume);
+          dtNrPointsRow.Values.Add(convexHull.Count);
+
+          sols = solutionCache.GetSolutionsFromGeneration(++i);
+        }
+
+        run.Results.Add("Convex Hull Measures", dt);
+      }
+    }
+
+    private double[] ConvertRealVectorToVertexArray(RealVector p) {
+      double[] vertex = p.Select(x => (double)x).ToArray();
+      return vertex;
+    }
+  }
+}